Package com.io7m.montarre.nativepack.internal.flatpak

# Class MNPackagerFlatpak

java.lang.Object
com.io7m.montarre.nativepack.internal.MNPackagerAbstract
com.io7m.montarre.nativepack.internal.flatpak.MNPackagerFlatpak

All Implemented Interfaces:
  `MNativePackagerServiceType`

public final class MNPackagerFlatpak extends MNPackagerAbstract implements MNativePackagerServiceType
A native packager that produces Flatpak packages.

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `MNPackagerFlatpak(MNativePackagerServiceProviderType inProvider, MNativeProcessesType inProcesses)`
  A native packager that produces Debian packages.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `Path`
  `execute(MNativeWorkspaceType workspace, MPackageReaderType reader)`
  Execute the packaging service.
  `Optional<com.io7m.seltzer.api.SStructuredErrorType<String>>`
  `unsupportedReason(Optional<MPackageDeclaration> packageVOpt)`
  Determine if the service can run on the current platform, and return the reason why it cannot (if it cannot).

  ### Methods inherited from class com.io7m.montarre.nativepack.internal.MNPackagerAbstract

  `describe, error, findBestIcon, findLicense, name, setAttribute, takeAttributes, translateVersion, unpackIcon, unpackLicense, writeReplaceOptions`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

  ### Methods inherited from interface com.io7m.montarre.api.natives.MNativePackagerServiceType

  `describe, name`

- ## Constructor Details

  - ### MNPackagerFlatpak

    public MNPackagerFlatpak(MNativePackagerServiceProviderType inProvider, MNativeProcessesType inProcesses)
    A native packager that produces Debian packages.
    Parameters:
      `inProvider` - The provider
      `inProcesses` - The processes

- ## Method Details

  - ### unsupportedReason

    public Optional<com.io7m.seltzer.api.SStructuredErrorType<String>> unsupportedReason(Optional<MPackageDeclaration> packageVOpt) throws InterruptedException
    Description copied from interface: `MNativePackagerServiceType`
    Determine if the service can run on the current platform, and return the reason why it cannot (if it cannot). Some services are unable to run outside specific platforms. For example, producing Windows MSI installers is limited to Windows platforms due to the requirement to run the Windows-only WiX toolkit.
    Specified by:
      `unsupportedReason` in interface `MNativePackagerServiceType`
    Parameters:
      `packageVOpt` - The package declaration
    Returns:
      The reason that this service is unsupported
    Throws:
      `InterruptedException` - On interruption

  - ### execute

    public Path execute(MNativeWorkspaceType workspace, MPackageReaderType reader) throws MException
    Description copied from interface: `MNativePackagerServiceType`
    Execute the packaging service.
    Specified by:
      `execute` in interface `MNativePackagerServiceType`
    Parameters:
      `workspace` - The workspace
      `reader` - The package
    Returns:
      The output file
    Throws:
      `MException` - On errors